package scheme;

import java.io.DataInputStream;
import antlr.collections.AST;
import scheme.parser.*;
import scheme.absyn.*;
import scheme.interp.*;

class REPL {
    public static void main (String[] args) {
        SchemeLexer lexer = new SchemeLexer(new DataInputStream(System.in));
        SchemeParser parser = new SchemeParser(lexer);
        SchemeTreeParser tree_parser = new SchemeTreeParser();
        while (true) {
            try {
                Eval_Exp interp = new Eval_Exp();
                System.out.print("Java cps> ");
                System.out.flush();
                parser.exp(); // start at the production for exp
                AST input_ast = parser.getAST();

                if (input_ast == null) System.exit(0);

                Exp exp = tree_parser.exp(input_ast);
                System.out.println("==>");
                exp.accept(interp);
            }
            catch (Done e) {
                System.out.println(e.get());
                continue;
            }
            catch (VisitE e) {
                System.out.println(e);
                continue;
            }
            catch (Throwable e) {
                e.printStackTrace();
                System.exit(-1);
            }
        }
    }
}
