package scheme.interp;

import scheme.util.List;
import scheme.absyn.Exp;

public class ClosureV extends SchemeValue {
    private List ids;
    private Exp body;
    private Env env;

    public ClosureV (List ids, Exp body, Env env) { 
        this.ids = ids;
        this.body = body;
        this.env = env; 
    }

    public void apply (List argVs, final Eval_Exp eval_exp) throws VisitE {
        final Continuation savedCont = eval_exp.getCont();
        final Env saved_env = eval_exp.getEnv();
        eval_exp.setEnv(env.addAll(ids,argVs));
        eval_exp.setCont(new Continuation () {
                public void invoke (SchemeValue v) throws VisitE {
                    eval_exp.setEnv(saved_env);
                    savedCont.invoke(v);
                    throw new Error(); // can never get here
                }
            });
        body.accept(eval_exp);
        throw new Error(); // can never get here
    }

    public String toString () {
        return "<procedure>";
    }
}
