package scheme.interp;

import scheme.util.*;

public abstract class Env {

    public abstract SchemeValue find (String x) throws VisitE;

    public abstract void set (String x, SchemeValue v) throws VisitE;

    public Env add (String x, SchemeValue v) {
        return new ExtendEnv(x,v,this);
    }

    public void setAll (List xs, List vs) throws VisitE {
        while (! (xs instanceof EmptyL)) {
            String x = (String) xs.hd();
            SchemeValue v = (SchemeValue) vs.hd();
            this.set(x,v);
            xs = xs.tl();
            vs = vs.tl();
        }
    }

    public Env addAll (List xs, List vs) {
        Env result = this;
        while (! (xs instanceof EmptyL)) {
            String x = (String) xs.hd();
            SchemeValue v = (SchemeValue) vs.hd();
            result = result.add(x,v);
            xs = xs.tl();
            vs = vs.tl();
        }
        return result;
    }

    public Env addAllVoid (List xs) {
        Env result = this;
        SchemeValue v = new VoidV();
        while (! (xs instanceof EmptyL)) {
            String x = (String) xs.hd();
            result = result.add(x,v);
            xs = xs.tl();
        }
        return result;
    }
}

