package scheme.interp;

import scheme.absyn.*;
import scheme.util.*;

public class Eval_ExpList implements ExpListVisitor {
    private List vals;
    private Eval_Exp eval_exp;
    private ContinuationL contL;

    public Eval_ExpList (Eval_Exp eval_exp) {
        this.eval_exp = eval_exp;
    }

    public void setContL (ContinuationL contL) {
        this.contL = contL;
    }

    public List getValues () { return vals; }

    public void visitEmptyExpL (EmptyExpL e) throws VisitE {
        contL.invoke(new EmptyL());
        throw new Error(); // can never get here
    }

    public void visitConsE (ConsE e) throws VisitE {
        final Exp hd = e.hd();
        final ExpList tl = e.tl();
        final ContinuationL savedContL = contL;
        eval_exp.setCont(new Continuation () {
                public void invoke (final SchemeValue hdv) throws VisitE {
                    contL = new ContinuationL () {
                            public void invoke (List tlvs) throws VisitE {
                                contL = savedContL;
                                vals = new Cons(hdv,tlvs);
                                contL.invoke(vals);
                                throw new Error(); // can never get here
                            }
                        };
                    tl.accept(Eval_ExpList.this);
                    throw new Error(); // can never get here
                }});
        hd.accept(eval_exp);
        throw new Error(); // can never get here
    }
}

